## mingw-w64-lldb-19.1.7-1.src.tar.zst

=== unittests/ValueObject/CMakeLists.txt ===
add_lldb_unittest(LLDBValueObjectTests
  DumpValueObjectOptionsTests.cpp

  LINK_LIBS
    lldbPluginPlatformLinux
    lldbPluginScriptInterpreterNone

  LINK_COMPONENTS
    Support
  )
