=== test/API/functionalities/data-formatter/data-formatter-stl/libstdcpp/map/Makefile ===
CXX_SOURCES := main.cpp

USE_LIBSTDCPP := 1

include Makefile.rules
